// Copyright (c) The Geekeey Authors
// SPDX-License-Identifier: EUPL-1.2

using Spectre.Console.Cli;

namespace Geekeey.Extensions.Process.Tests.Dummy.Commands;

internal sealed class EnvironmentCommand : AsyncOutputCommand<EnvironmentCommand.Settings>
{
	public sealed class Settings : OutputCommandSettings
	{
		[CommandArgument(0, "<ARGUMENT>")] public string[] Variables { get; init; } = [];
	}

	public override async Task<int> ExecuteAsync(CommandContext context, Settings settings)
	{
		using var tty = Terminal.Connect();

		foreach (var name in settings.Variables)
		{
			var value = Environment.GetEnvironmentVariable(name) ?? string.Empty;

			foreach (var writer in tty.GetWriters(settings.Target))
			{
				await writer.WriteLineAsync(value);
			}
		}

		return 0;
	}
}