// Copyright (c) The Geekeey Authors
// SPDX-License-Identifier: EUPL-1.2

using Spectre.Console.Cli;

namespace Geekeey.Extensions.Process.Tests.Dummy.Commands;

internal sealed class ExitCommand : AsyncCommand<ExitCommand.Settings>
{
	public sealed class Settings : CommandSettings
	{
		[CommandArgument(1, "<code>")] public int Code { get; init; }
	}

	public override async Task<int> ExecuteAsync(CommandContext context, Settings settings)
	{
		using var tty = Terminal.Connect();

		await tty.Stderr.WriteLineAsync($"Exit code set to {settings.Code}");

		return settings.Code;
	}
}