// Copyright (c) The Geekeey Authors
// SPDX-License-Identifier: EUPL-1.2

namespace Geekeey.Extensions.Process.Tests.Dummy;

[Flags]
public enum OutputTarget
{
	StdOut = 1,
	StdErr = 2,
	All = StdOut | StdErr
}

internal static class OutputTargetExtensions
{
	public static IEnumerable<StreamWriter> GetWriters(this Terminal terminal, OutputTarget target)
	{
		if (target.HasFlag(OutputTarget.StdOut))
			yield return terminal.Stdout;

		if (target.HasFlag(OutputTarget.StdErr))
			yield return terminal.Stderr;
	}
}