// Copyright (c) The Geekeey Authors
// SPDX-License-Identifier: EUPL-1.2

namespace Geekeey.Extensions.Process.Tests;

internal static class ProcessTree
{
	public static bool HasExited(int id)
	{
		try
		{
			using var process = System.Diagnostics.Process.GetProcessById(id);
			return process.HasExited;
		}
		catch
		{
			// GetProcessById throws if the process can not be found, which means it is not running!
			return true;
		}
	}
}