// Copyright (c) The Geekeey Authors
// SPDX-License-Identifier: EUPL-1.2

using System.Reflection;

namespace Geekeey.Extensions.Process.Tests;

internal sealed class TestTempDirectory(string path) : IDisposable
{
	public static TestTempDirectory Create()
	{
		var location = Assembly.GetExecutingAssembly().Location;
		var pwd = System.IO.Path.GetDirectoryName(location) ?? Directory.GetCurrentDirectory();
		var dirPath = System.IO.Path.Combine(pwd, "Temp", Guid.NewGuid().ToString());

		Directory.CreateDirectory(dirPath);

		return new TestTempDirectory(dirPath);
	}

	public string Path { get; } = path;

	public void Dispose()
	{
		try
		{
			Directory.Delete(Path, true);
		}
		catch (DirectoryNotFoundException) { }
	}
}