# Process.Win.Notify

The sending of signals on Windows is difficult so say not the least. If one wishes to send a ctrl signal to a process in
windows, one can't do that. Instead, one can only send a signal to a [process group or console][process-group] . So in
order to use a process group, one must specify the creation of a process group (process tree) when creating a process.
This is currently not possible with the dotnet api ([api-suggestion](https://github.com/dotnet/runtime/issues/44944))

An alternative solution is to use the concept of the [console][process-group] and the fact that
the [`GenerateConsoleCtrlEvent`][generate-console-ctrl-event] can also send a signal to all processes which are
connected to a console when providing the `dwProcessGroupId` with the value `0`.
This project create an executable which detaches its own console and attaches itself to the targeted process and sends
the requested signal to the console.

[process-group]: https://learn.microsoft.com/en-us/windows/console/console-process-groups
[generate-console-ctrl-event]: https://learn.microsoft.com/en-us/windows/console/generateconsolectrlevent