﻿// Copyright (c) The Geekeey Authors
// SPDX-License-Identifier: EUPL-1.2

using Geekeey.Extensions.Process;

namespace Geekeey.Extensions.Process;

/// <summary>
/// Exception thrown when the command fails to execute correctly.
/// </summary>
public class CommandExecutionException(
	Command command,
	int exitCode,
	string message,
	Exception? innerException = null) : Exception(message, innerException)
{
	/// <summary>
	/// Command that triggered the exception.
	/// </summary>
	public Command Command { get; } = command;

	/// <summary>
	/// Exit code returned by the process.
	/// </summary>
	public int ExitCode { get; } = exitCode;
}