// Copyright (c) The Geekeey Authors
// SPDX-License-Identifier: EUPL-1.2

namespace Geekeey.Extensions.Process;

/// <summary>
/// A class containing various utility methods, a 'prelude' to the rest of the library.
/// </summary>
/// <remarks>
/// This class is meant to be imported statically, e.g. <c>using static Geekeey.Extensions.Process.Prelude;</c>.
/// Recommended to be imported globally via a global using statement.
/// </remarks>
public static class Prelude
{
	/// <summary>
	///  Creates a new command that targets the specified command-line executable, batch file, or script.
	/// </summary>
	/// <param name="targetFilePath">The name of the file to be executed.</param>
	/// <returns>A command representing the parameters used to execute the executable.</returns>
	public static Command Run(string targetFilePath) => new(targetFilePath);
}